; VIIRS aerosol EDR data

tmp ={VAVAR, $
      dataType:0B, $ ; data type: 0: categorical integer value
                     ;            1: continuous float-point value
      edrType:0B, $  ; EDR type:  0: AOD/APSP EDR
                     ;            1: Suspended Matter EDR
                     ;            2: EDR geometry
                     ;            3: SDR
                     ;            4: AOT IP
                     ;            5: Cloud Mask IP
                     ;            6: AMI IP
      name:'', $     ; variable name
      dataRange:FLTARR(2), $  ; data range
      imageTitle:'', $        ; title shown in image
      nLevels:0, $            ; number of major mark intervals in colorbar
      annotation:Ptr_New()}   ; annontation

nullPtr = Ptr_New()
biAnnPtr = Ptr_New(['False','True'])
qcAnnPtr = Ptr_New(['High','Degraded','Excluded','Not Produced'])
cldAnnPtr = Ptr_New(['Confident Clear','Probably Clear','Probably Cloudy','Confident Cloudy'])
biCldAnnPtr = Ptr_New(['Clear','Cloudy'])
pdcAnnPtr = Ptr_New(['Not Produced','Low','Medium','High'])

NviirsEdrVar = 59    ; number of VIIRS aerosol EDR variables to be displayed
NviirsAotIPVar = 27  ; number of VIIRS aerosol IP variables to be displayed
NviirsAmiIPVar = 4   ; number of VIIRS aerosol model IP  variables to be displayed
NviirsCmIPVar = 31  ; number of VIIRS cloud mask IP variables to be displayed
NviirsAerVar = NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+NviirsCmIPVar  ; number of VIIRS variables to be displayed
viirsAerVar = Replicate({VAVAR}, NviirsAerVar)
aodRange = [0., 1.]

viirsAerVar[0] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_550nm',aodRange,'Aerosol Optical Thickness at 550nm',10,nullPtr}
viirsAerVar[1] = {VAVAR,1B,0B,'AngstromExponent',[-0.5,2.], 'Angstrom Exponent',5,nullPtr}
viirsAerVar[2] = {VAVAR,1B,0B,'SmallModeFraction',[0.,100.],'Fine Mode Fraction (Over Ocean)',10,nullPtr}
viirsAerVar[3] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_412nm',aodRange,'Aerosol Optical Thickness at 412nm',10,nullPtr}
viirsAerVar[4] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_445nm',aodRange,'Aerosol Optical Thickness at 445nm',10,nullPtr}
viirsAerVar[5] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_488nm',aodRange,'Aerosol Optical Thickness at 488nm',10,nullPtr}
viirsAerVar[6] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_555nm',aodRange,'Aerosol Optical Thickness at 555nm',10,nullPtr}
viirsAerVar[7] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_672nm',aodRange,'Aerosol Optical Thickness at 672nm',10,nullPtr}
viirsAerVar[8] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_746nm',aodRange,'Aerosol Optical Thickness at 746nm',10,nullPtr}
viirsAerVar[9] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_865nm',aodRange,'Aerosol Optical Thickness at 865nm',10,nullPtr}
viirsAerVar[10] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_1240nm',aodRange,'Aerosol Optical Thickness at 1240nm',10,nullPtr}
viirsAerVar[11] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_1610nm',aodRange,'Aerosol Optical Thickness at 1610nm',10,nullPtr}
viirsAerVar[12] = {VAVAR,1B,0B,'AerosolOpticalDepth_at_2250nm',aodRange,'Aerosol Optical Thickness at 2250nm',10,nullPtr}
viirsAerVar[13] = {VAVAR,0B,0B,'QF1_VIIRSAEROEDR_0_1',[0,4],'AOT Product Quality',4,pdcAnnPtr}
viirsAerVar[14] = {VAVAR,0B,0B,'QF1_VIIRSAEROEDR_2_3',[0,4],'Angstrom Exponent Product Quality',4,pdcAnnPtr}
viirsAerVar[15] = {VAVAR,0B,0B,'QF1_VIIRSAEROEDR_4_5',[0,3],'AeroEDR - Land/Ocean',3,Ptr_New(['Land','Ocean','Excluded/Not Produced'])}
viirsAerVar[16] = {VAVAR,0B,0B,'QF1_VIIRSAEROEDR_6',[0,2],'AOT Out of Range Flag',2,biAnnPtr}
viirsAerVar[17] = {VAVAR,0B,0B,'QF1_VIIRSAEROEDR_7',[0,2],'Angstrom Exponent Out of Range Flag',2,biAnnPtr}
viirsAerVar[18] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_0',[0,2],'AeroEDR - Cloud Contamination Flag',2,biAnnPtr}
viirsAerVar[19] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_1',[0,2],'AeroEDR - Cloud Adjacent Flag',2,biAnnPtr}
viirsAerVar[20] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_2',[0,2],'AeroEDR - Cirrus Contamination Flag',2,biAnnPtr}
viirsAerVar[21] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_3',[0,2],'AeroEDR - Bad SDR Flag',2,biAnnPtr}
viirsAerVar[22] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_4',[0,2],'AeroEDR - Sun Glint Flag',2,biAnnPtr}
viirsAerVar[23] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_5',[0,2],'AeroEDR - Cloud Shadow Flag',2,biAnnPtr}
viirsAerVar[24] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_6',[0,2],'AeroEDR - Snow/Ice Flag',2,biAnnPtr}
viirsAerVar[25] = {VAVAR,0B,0B,'QF2_VIIRSAEROEDR_7',[0,2],'AeroEDR - Fire Flag',2,biAnnPtr}
viirsAerVar[26] = {VAVAR,0B,0B,'QF3_VIIRSAEROEDR_0',[0,2],'AeroEDR - Low Sun (65<SZA<=80)',2,biAnnPtr}
viirsAerVar[27] = {VAVAR,0B,0B,'QF3_VIIRSAEROEDR_1',[0,2],'AeroEDR - Low Sun (SZA>80)',2,biAnnPtr}
viirsAerVar[28] = {VAVAR,0B,0B,'QF3_VIIRSAEROEDR_2',[0,2],'AeroEDR - Bright Land Surface or Turbid Water',2,biAnnPtr}
viirsAerVar[29] = {VAVAR,0B,0B,'QF3_VIIRSAEROEDR_3',[0,2],'AeroEDR - Excluded Angstrom Exponent (AOT550<0.15)',2,biAnnPtr}
viirsAerVar[30] = {VAVAR,0B,0B,'QF4_VIIRSAEROEDR_0_1_2',[0,6],'Land Model Aerosol Index',6,Ptr_New(['Dust','Smoke-HighAbs','Smoke-LowAbs','Urban-Clean','Urban-Polluted','Not Land'])}
viirsAerVar[31] = {VAVAR,0B,0B,'QF5_VIIRSAEROEDR_0_1_2',[0,5],'Small Mode Aerosol Model (Ocean Only)',5,Ptr_New(['FineMode-1','FineMode-2','FineMode-3','FineMode-4','Not Ocean'])}
viirsAerVar[32] = {VAVAR,0B,0B,'QF5_VIIRSAEROEDR_3_4_5',[0,6],'Large Mode Aerosol Model (Ocean Only)',6,Ptr_New(['CoarseMode-1','CoarseMode-2','CoarseMode-3','CoarseMode-4','CoarseMode-5','Not Ocean'])}
viirsAerVar[33] = {VAVAR,1B,1B,'SmokeConcentration',[0.,200.],'Smoke Concentration [ug/m3]',10,nullPtr}
viirsAerVar[34] = {VAVAR,0B,1B,'SuspendedMatterType',[0,6],'Suspended Matter Type',6,Ptr_New(['Ash','Dust','Smoke','Sea Salt','Unknown','None'])}
viirsAerVar[35] = {VAVAR,0B,1B,'QF1_VIIRSSusMatEDR_0_1',[0,4],'Suspended Matter Detection Product Quality',4,pdcAnnPtr}
viirsAerVar[36] = {VAVAR,0B,1B,'QF1_VIIRSSusMatEDR_2_3',[0,4],'Suspended Matter Type Product Quality',4,pdcAnnPtr}
viirsAerVar[37] = {VAVAR,0B,1B,'QF1_VIIRSSusMatEDR_4_5',[0,4],'Smoke Concentration Product Quality',4,pdcAnnPtr}
viirsAerVar[38] = {VAVAR,0B,1B,'QF1_VIIRSSusMatEDR_6_7',[0,3],'SusMatEDR - Land/Ocean',3,Ptr_New(['Land','Ocean','Excluded/Not Produced'])}
viirsAerVar[39] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_0',[0,2],'SusMatEDR - Cloud Contamination Flag',2,biAnnPtr}
viirsAerVar[40] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_1',[0,2],'SusMatEDR - Cloud Adjacent Flag',2,biAnnPtr}
viirsAerVar[41] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_2',[0,2],'SusMatEDR - Cirrus Contamination Flag',2,biAnnPtr}
viirsAerVar[42] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_3',[0,2],'SusMatEDR - Bad SDR Flag',2,biAnnPtr}
viirsAerVar[43] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_4',[0,2],'SusMatEDR - Sun Glint Flag',2,biAnnPtr}
viirsAerVar[44] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_5',[0,2],'SusMatEDR - Cloud Shadow Flag',2,biAnnPtr}
viirsAerVar[45] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_6',[0,2],'SusMatEDR - Snow/Ice Flag',2,biAnnPtr}
viirsAerVar[46] = {VAVAR,0B,1B,'QF2_VIIRSSusMatEDR_7',[0,2],'SusMatEDR - Fire Flag',2,biAnnPtr}
viirsAerVar[47] = {VAVAR,0B,1B,'QF3_VIIRSSusMatEDR_0',[0,2],'Smoke Concentration Out of Expected Range',2,biAnnPtr}
viirsAerVar[48] = {VAVAR,0B,1B,'QF3_VIIRSSusMatEDR_1',[0,2],'Excluded SusMat Typing for AOT550<1.0',2,biAnnPtr}
viirsAerVar[49] = {VAVAR,0B,1B,'QF3_VIIRSSusMatEDR_2',[0,2],'Excluded SusMat Detection for AOT550<0.5',2,biAnnPtr}
viirsAerVar[50] = {VAVAR,0B,1B,'QF3_VIIRSSusMatEDR_3',[0,2],'SusMatEDR - Low Sun (SZA>65)',2,biAnnPtr}
viirsAerVar[51] = {VAVAR,0B,1B,'QF3_VIIRSSusMatEDR_4',[0,2],'SusMatEDR - Bright Land Surface or Turbid Water',2,biAnnPtr}
viirsAerVar[52] = {VAVAR,1B,2B,'SolarZenithAngle',[0.,90.],'Solar Zenith Angle [Degree]',9,nullPtr}
viirsAerVar[53] = {VAVAR,1B,2B,'SatelliteZenithAngle',[0.,90.],'Satellite Zenith Angle [Degree]',9,nullPtr}
viirsAerVar[54] = {VAVAR,1B,2B,'SolarAzimuthAngle',[-180.,180.],'Solar Azimuth Angle [Degree]',9,nullPtr}
viirsAerVar[55] = {VAVAR,1B,2B,'SatelliteAzimuthAngle',[-180.,180.],'Satellite Azimuth Angle [Degree]',9,nullPtr}
viirsAerVar[56] = {VAVAR,1B,2B,'Height',[0.,2000.],'Surface Height [m]',10,nullPtr}
viirsAerVar[57] = {VAVAR,1B,2B,'Der_RelAziAngle',[0.,180.],'Relative Azimuth Angle [Degree]',9,nullPtr}
viirsAerVar[58] = {VAVAR,1B,2B,'Der_ScatteringAngle',[0.,180.],'Scattering Angle [Degree]',9,nullPtr}

; VIIRS AOT IP
viirsAerVar[NviirsEdrVar+0] = {VAVAR,1B,4B,'faot550',aodRange,'Aerosol Optical Thickness (IP) at 550nm',10,nullPtr}
viirsAerVar[NviirsEdrVar+1] = {VAVAR,1B,4B,'aotSlant550',aodRange,'Slant Aerosol Optical Thickness (IP) at 550nm',10,nullPtr}
viirsAerVar[NviirsEdrVar+2] = {VAVAR,1B,4B,'angexp',[-1.,3.],'Aerosol Angstrom Exponent (IP)',8,nullPtr}
viirsAerVar[NviirsEdrVar+3] = {VAVAR,0B,4B,'QF1_0_1',[0,4],'IP AOT Quality',4,qcAnnPtr}
viirsAerVar[NviirsEdrVar+4] = {VAVAR,0B,4B,'QF1_2_3',[0,4],'IP Angstrom Exponent Quality',4,qcAnnPtr}
viirsAerVar[NviirsEdrVar+5] = {VAVAR,0B,4B,'QF1_4_5',[0,4],'IP Suspended Matter Type Quality',4,qcAnnPtr}
viirsAerVar[NviirsEdrVar+6] = {VAVAR,0B,4B,'QF1_6_7',[0,4],'IP Cloud Mask Quality',4,Ptr_New(['Poor','Low','Medium','High'])}
viirsAerVar[NviirsEdrVar+7] = {VAVAR,0B,4B,'QF2_0_1',[0,4],'IP Cloud Confidence',4,cldAnnPtr}
viirsAerVar[NviirsEdrVar+8] = {VAVAR,0B,4B,'QF2_2_3',[0,4],'IP Adjacent Pixel Cloud Confidence',4,cldAnnPtr}
viirsAerVar[NviirsEdrVar+9] = {VAVAR,0B,4B,'QF2_4_5_6',[0,7],'IP Land/Water',7,$
                               Ptr_New(['Desert','Land','Ind/Water','Sea','','Coastal','Ephe/Water'])}
viirsAerVar[NviirsEdrVar+10]= {VAVAR,0B,4B,'QF2_7',[0,2],'IP Bad SDR',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+11]= {VAVAR,0B,4B,'QF3_0_1',[0,4],'IP Day/Night',4,Ptr_New(['Day','Low Sun/Degraded','Twilight/Excluded','Night'])}
viirsAerVar[NviirsEdrVar+12]= {VAVAR,0B,4B,'QF3_2_3_4',[0,4],'IP Interpolation/NAPPS/Climatology Processing Used',4, $
                               Ptr_New(['None','Interpolation Only','Interpolation and Clim/NAAPS','Climatology/NAAPS'])}
viirsAerVar[NviirsEdrVar+13]= {VAVAR,0B,4B,'QF3_5_6_7',[0,8],'IP Sun Glint',8, $
                               Ptr_New(['None','Geometry','Wind','Geo&Wnd','Internal', 'Int&Geo','Int&Wnd','All'])}
viirsAerVar[NviirsEdrVar+14]= {VAVAR,0B,4B,'QF4_0',[0,2],'IP Snow/Ice',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+15]= {VAVAR,0B,4B,'QF4_1',[0,2],'IP Cirrus',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+16]= {VAVAR,0B,4B,'QF4_2',[0,2],'IP Cloud Shadow',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+17]= {VAVAR,0B,4B,'QF4_3',[0,2],'IP Fire',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+18]= {VAVAR,0B,4B,'QF4_4_5',[0,3],'IP Bright Land Pixel',3,Ptr_New(['Dark','Soil Dominated','Bright'])}
viirsAerVar[NviirsEdrVar+19]= {VAVAR,0B,4B,'QF4_6',[0,2],'IP Turbid/Shallow Water',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+20]= {VAVAR,0B,4B,'QF4_7',[0,2],'IP Ash',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+21]= {VAVAR,0B,4B,'QF5_0',[0,2],'IP Low AOT - SM Typing Excluded',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+22]= {VAVAR,0B,4B,'QF5_1',[0,2],'IP Low AOT - SM Detection Excluded',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+23]= {VAVAR,0B,4B,'QF5_2',[0,2],'IP AOT Out of Spec Range',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+24]= {VAVAR,0B,4B,'QF5_3',[0,2],'IP APSP Out of Spec Range',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+25]= {VAVAR,0B,4B,'QF5_4',[0,2],'IP Low AOT - APSP Excluded',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+26]= {VAVAR,0B,4B,'QF5_5',[0,2],'IP Residual Threshold Exceeded',2,biAnnPtr}

; VIIRS AMI IP
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+0] = {VAVAR,0B,6B,'amdl',[0,6],'IP Aerosol Model',6,Ptr_New(['Dust','Smoke-HighAbs','Smoke-LowAbs','Urban-Clean','Urban-Polluted','Dynamic-Ocean'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+1] = {VAVAR,1B,6B,'combo',[0.,100.],'IP Fine Mode Fraction (Over Ocean)',10, nullPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+2] = {VAVAR,0B,6B,'smmdl',[0,4],'IP Small Mode Aerosol Model (Ocean Only)',4,Ptr_New(['FineMode-1','FineMode-2','FineMode-3','FineMode-4'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+3] = {VAVAR,0B,6B,'lgmdl',[0,5],'IP Large Mode Aerosol Model (Ocean Only)',5,Ptr_New(['CoarseMode-1','CoarseMode-2','CoarseMode-3','CoarseMode-4','CoarseMode-5'])}


; Cloud Mask IP
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+0] = {VAVAR,0B,5B,'QF1_VIIRSCMIP_0_1',[0,4],'VCM Cloud Mask Quality',4,Ptr_New(['Poor','Low','Medium','High'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+1] = {VAVAR,0B,5B,'QF1_VIIRSCMIP_2_3',[0,4],'VCM Cloud Detection Confidence',4,cldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+2] = {VAVAR,0B,5B,'QF1_VIIRSCMIP_4',[0,2],'VCM Day/Night',2,Ptr_New(['Night','Day'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+3] = {VAVAR,0B,5B,'QF1_VIIRSCMIP_5',[0,2],'VCM Snow/Ice',2,biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+4] = {VAVAR,0B,5B,'QF1_VIIRSCMIP_6_7',[0,4],'VCM Sun Glint',4, Ptr_New(['None','Geo-Based','WndSpd-Based','Geo&Wind-Based'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+5] = {VAVAR,0B,5B,'QF2_VIIRSCMIP_0_1_2',[0,6],'VCM Land/Water',6, Ptr_New(['Desert','Land','Ind/Water','Sea','','Coastal'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+6] = {VAVAR,0B,5B,'QF2_VIIRSCMIP_3',[0,2],'VCM Shadow',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+7] = {VAVAR,0B,5B,'QF2_VIIRSCMIP_4',[0,2],'VCM Heavy Aerosol',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+8] = {VAVAR,0B,5B,'QF2_VIIRSCMIP_5',[0,2],'VCM Fire',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+9] = {VAVAR,0B,5B,'QF2_VIIRSCMIP_6',[0,2],'VCM Cirrus (SW Test)',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+10]= {VAVAR,0B,5B,'QF2_VIIRSCMIP_7',[0,2],'VCM Cirrus (IR Test)',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+11]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_0',[0,2],'VCM IR Threshold Cloud Test (M15)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+12]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_1',[0,2],'VCM High Cloud Test (M12-M16)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+13]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_2',[0,2],'VCM IR Temperature Difference Test (M14-M15; M15-M16)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+14]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_3',[0,2],'VCM Temperature Difference Test (M15-M12)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+15]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_4',[0,2],'VCM Temperature Difference Test (M12-M13)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+16]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_5',[0,2],'VCM Visible Reflectance Test (M5)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+17]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_6',[0,2],'VCM Visible Reflectance Test (M7; M1)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+18]= {VAVAR,0B,5B,'QF3_VIIRSCMIP_7',[0,2],'VCM Visible Ratio Test (M7/M5)',2, biCldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+19]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_0_1',[0,4],'VCM Adjacent Cloud Confidence',4, cldAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+20]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_2',[0,2],'VCM Conifer Boreal Forest',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+21]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_3',[0,2],'VCM Spatial Uniformity Test Passed',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+22]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_4',[0,2],'VCM Dust Candidate',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+23]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_5',[0,2],'VCM Smoke Candidate',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+24]= {VAVAR,0B,5B,'QF4_VIIRSCMIP_6',[0,2],'VCM Dust or Volcanic Ash Present',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+25]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_0_1_2',[0,8],'VCM Cloud Phase',8, $
                                              Ptr_New(['N/A','Clear','Partly', 'Water','Supercool/Mix', 'Opaque Ice','Cirrus','Overlap'])}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+26]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_3',[0,2],'VCM Thin Cirrus',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+27]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_4',[0,2],'VCM Ephemeral Water',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+28]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_5',[0,2],'VCM Degraded (0.2<TOC NDVI<0.4)',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+29]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_6',[0,2],'VCM Degraded (Sun Glint)',2, biAnnPtr}
viirsAerVar[NviirsEdrVar+NviirsAotIPVar+NviirsAmiIPVar+30]= {VAVAR,0B,5B,'QF6_VIIRSCMIP_7',[0,2],'VCM Degraded (Polar Night)',2, biAnnPtr}


tmp ={VASDR, $
      dataType:0B, $ ; data type: 0: categorical integer value
                     ;            1: continuous float-point value
      Channel:0B, $  ; VIIRS Channel:  1: M1; 2: M2; ......; 11: M11
      name:'', $     ; variable name
      dataRange:FLTARR(2), $  ; data range
      imageTitle:'', $        ; title shown in image
      nLevels:0, $            ; number of major mark intervals in colorbar
      annotation:Ptr_New()}   ; annontation

NviirsSdrVar = 84    ; number of VIIRS SDR variables to be displayed (8*14)
ViirsSdrVar = Replicate({VASDR}, NviirsSdrVar)

sdr_qf_quality_ptr = Ptr_New(['Good','Poor','No Calibration'])
sdr_qf_saturate_ptr = Ptr_New(['None','Some','All'])
sdr_qf_missing_ptr = Ptr_New(['All Data Present','EV RDR Data Missing','Cal Data Missing','Thermistor Data Missing'])
sdr_qf_outrange_ptr = Ptr_New(['All Data Within Range','Radiance Out of Range','Refl or EBBT Out',$
                               'Both Rad and Refl or EBBT Out'])

; M1
ViirsSdrVar[0]  = {VASDR,1B,1B,'Radiance',[0., 400.],'SDR M1 Radiance [W/m2*sr*um]',8,nullPtr}
ViirsSdrVar[1]  = {VASDR,1B,1B,'Reflectance',[0., 0.5],'SDR M1 Reflectance',10,nullPtr}
ViirsSdrVar[2]  = {VASDR,0B,1B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M1 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[3]  = {VASDR,0B,1B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M1 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[4]  = {VASDR,0B,1B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M1 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[5]  = {VASDR,0B,1B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M1 - Out of Range',4,sdr_qf_outrange_ptr}

; M2
ViirsSdrVar[6]  = {VASDR,1B,2B,'Radiance',[0., 400.],'SDR M2 Radiance [W/m2*sr*um]',8,nullPtr}
ViirsSdrVar[7]  = {VASDR,1B,2B,'Reflectance',[0., 0.5],'SDR M2  Reflectance',10,nullPtr}
ViirsSdrVar[8]  = {VASDR,0B,2B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M2  - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[9]  = {VASDR,0B,2B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M2  - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[10] = {VASDR,0B,2B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M2  - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[11] = {VASDR,0B,2B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M2  - Out of Range',4,sdr_qf_outrange_ptr}

; M3
ViirsSdrVar[12] = {VASDR,1B,3B,'Radiance',[0., 400.],'SDR M3 Radiance [W/m2*sr*um]',8,nullPtr}
ViirsSdrVar[13] = {VASDR,1B,3B,'Reflectance',[0., 0.5],'SDR M3 Reflectance',10,nullPtr}
ViirsSdrVar[14] = {VASDR,0B,3B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M3 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[15] = {VASDR,0B,3B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M3 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[16] = {VASDR,0B,3B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M3 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[17] = {VASDR,0B,3B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M3 - Out of Range',4,sdr_qf_outrange_ptr}

; M4
ViirsSdrVar[18] = {VASDR,1B,4B,'Radiance',[0., 400.],'SDR M4 Radiance [W/m2*sr*um]',8,nullPtr}
ViirsSdrVar[19] = {VASDR,1B,4B,'Reflectance',[0., 0.5],'SDR M4 Reflectance',10,nullPtr}
ViirsSdrVar[20] = {VASDR,0B,4B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M4 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[21] = {VASDR,0B,4B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M4 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[22] = {VASDR,0B,4B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M4 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[23] = {VASDR,0B,4B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M4 - Out of Range',4,sdr_qf_outrange_ptr}

; M5
ViirsSdrVar[24] = {VASDR,1B,5B,'Radiance',[0., 400.],'SDR M5 Radiance [W/m2*sr*um]',8,nullPtr}
ViirsSdrVar[25] = {VASDR,1B,5B,'Reflectance',[0., 0.5],'SDR M5 Reflectance',10,nullPtr}
ViirsSdrVar[26] = {VASDR,0B,5B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M5 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[27] = {VASDR,0B,5B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M5 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[28] = {VASDR,0B,5B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M5 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[29] = {VASDR,0B,5B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M5 - Out of Range',4,sdr_qf_outrange_ptr}

; M6
ViirsSdrVar[30] = {VASDR,1B,6B,'Radiance',[0., 200.],'SDR M6 Radiance [W/m2*sr*um]',10,nullPtr}
ViirsSdrVar[31] = {VASDR,1B,6B,'Reflectance',[0., 0.2],'SDR M6 Reflectance',10,nullPtr}
ViirsSdrVar[32] = {VASDR,0B,6B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M6 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[33] = {VASDR,0B,6B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M6 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[34] = {VASDR,0B,6B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M6 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[35] = {VASDR,0B,6B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M6 - Out of Range',4,sdr_qf_outrange_ptr}

; M7
ViirsSdrVar[36] = {VASDR,1B,7B,'Radiance',[0., 200.],'SDR M7 Radiance [W/m2*sr*um]',10,nullPtr}
ViirsSdrVar[37] = {VASDR,1B,7B,'Reflectance',[0., 0.6],'SDR M7 Reflectance',6,nullPtr}
ViirsSdrVar[38] = {VASDR,0B,7B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M7 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[39] = {VASDR,0B,7B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M7 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[40] = {VASDR,0B,7B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M7 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[41] = {VASDR,0B,7B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M7 - Out of Range',4,sdr_qf_outrange_ptr}

; M8
ViirsSdrVar[42] = {VASDR,1B,8B,'Radiance',[0., 100.],'SDR M8 Radiance [W/m2*sr*um]',10,nullPtr}
ViirsSdrVar[43] = {VASDR,1B,8B,'Reflectance',[0., 0.5],'SDR M8 Reflectance',10,nullPtr}
ViirsSdrVar[44] = {VASDR,0B,8B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M8 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[45] = {VASDR,0B,8B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M8 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[46] = {VASDR,0B,8B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M8 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[47] = {VASDR,0B,8B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M8 - Out of Range',4,sdr_qf_outrange_ptr}

; M9
ViirsSdrVar[48] = {VASDR,1B,9B,'Radiance',[0., 100.],'SDR M9 Radiance [W/m2*sr*um]',10,nullPtr}
ViirsSdrVar[49] = {VASDR,1B,9B,'Reflectance',[0., 0.5],'SDR M9 Reflectance',10,nullPtr}
ViirsSdrVar[50] = {VASDR,0B,9B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M9 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[51] = {VASDR,0B,9B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M9 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[52] = {VASDR,0B,9B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M9 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[53] = {VASDR,0B,9B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M9 - Out of Range',4,sdr_qf_outrange_ptr}

; M10
ViirsSdrVar[54] = {VASDR,1B,10B,'Radiance',[0., 50.],'SDR M10 Radiance [W/m2*sr*um]',5,nullPtr}
ViirsSdrVar[55] = {VASDR,1B,10B,'Reflectance',[0., 0.5],'SDR M10 Reflectance',10,nullPtr}
ViirsSdrVar[56] = {VASDR,0B,10B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M10 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[57] = {VASDR,0B,10B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M10 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[58] = {VASDR,0B,10B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M10 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[59] = {VASDR,0B,10B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M10 - Out of Range',4,sdr_qf_outrange_ptr}

; M11
ViirsSdrVar[60] = {VASDR,1B,11B,'Radiance',[0., 30.],'SDR M11 Radiance [W/m2*sr*um]',6,nullPtr}
ViirsSdrVar[61] = {VASDR,1B,11B,'Reflectance',[0., 0.5],'SDR M11 Reflectance',10,nullPtr}
ViirsSdrVar[62] = {VASDR,0B,11B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M11 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[63] = {VASDR,0B,11B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M11 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[64] = {VASDR,0B,11B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M11 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[65] = {VASDR,0B,11B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M11 - Out of Range',4,sdr_qf_outrange_ptr}

; M12
ViirsSdrVar[66] = {VASDR,1B,12B,'Radiance',[0., 1.],'SDR M12 Radiance [W/m2*sr*um]',10,nullPtr}
ViirsSdrVar[67] = {VASDR,1B,12B,'BrightnessTemperature',[270.,320.],'SDR M12 Brightness Temperature',10,nullPtr}
ViirsSdrVar[68] = {VASDR,0B,12B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M12 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[69] = {VASDR,0B,12B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M12 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[70] = {VASDR,0B,12B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M12 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[71] = {VASDR,0B,12B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M12 - Out of Range',4,sdr_qf_outrange_ptr}

; M15 (Channel-2)
ViirsSdrVar[72] = {VASDR,1B,13B,'Radiance',[0., 30.],'SDR M15 Radiance [W/m2*sr*um]',6,nullPtr}
ViirsSdrVar[73] = {VASDR,1B,13B,'BrightnessTemperature',[250.,300.],'SDR M15 Brightness Temperature [K]',10,nullPtr}
ViirsSdrVar[74] = {VASDR,0B,13B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M15 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[75] = {VASDR,0B,13B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M15 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[76] = {VASDR,0B,13B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M15 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[77] = {VASDR,0B,13B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M15 - Out of Range',4,sdr_qf_outrange_ptr}

; M16 (Channel-2)
ViirsSdrVar[78] = {VASDR,1B,14B,'Radiance',[0., 30.],'SDR M16 Radiance [W/m2*sr*um]',6,nullPtr}
ViirsSdrVar[79] = {VASDR,1B,14B,'BrightnessTemperature',[250.,300.],'SDR M16 Brightness Temperature [K]',10,nullPtr}
ViirsSdrVar[80] = {VASDR,0B,14B,'QF1_VIIRSMBANDSDR_0_1',[0,3],'SDR M16 - Quality', 3, sdr_qf_quality_ptr}
ViirsSdrVar[81] = {VASDR,0B,14B,'QF1_VIIRSMBANDSDR_2_3',[0,3],'SDR M16 - Saturated Pixel',3,sdr_qf_saturate_ptr}
ViirsSdrVar[82] = {VASDR,0B,14B,'QF1_VIIRSMBANDSDR_4_5',[0,4],'SDR M16 - Missing Data',4,sdr_qf_missing_ptr}
ViirsSdrVar[83] = {VASDR,0B,14B,'QF1_VIIRSMBANDSDR_6_7',[0,4],'SDR M16 - Out of Range',4,sdr_qf_outrange_ptr}
